//                                                                  
// Copyright  2005 Lidor Systems.
// All Rights Reserved.
//
// This file is part of the "LidorSystems.Collector" class Library. 
//                                                                   
// The contents of this file are subject to the LidorSystems.Collector
// License (the "License"), and may not be used except in compliance
// with the License. A copy of the License should have been installed
// in the product's root installation directory. You may also obtain a
// copy of the License at...
//                                                                   
// http://www.lidorsystems.com/products/collector/agreement.html
//                                                             
// Software distributed under this License is distributed on an 
// "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
// implied. See the License for the specific language governing 
// rights and limitations under the License.                        
//                                                                  

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using LidorSystems.Collector;
using LidorSystems.Collector.Style;

namespace StandardMDI
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.RadioButton rbTiled;
		private System.Windows.Forms.RadioButton rbHorizontal;
		private System.Windows.Forms.RadioButton rbVertical;
		private System.Windows.Forms.RadioButton rbCascade;
		private LidorSystems.Collector.Group group2;
		private LidorSystems.Collector.Group group3;
		private LidorSystems.Collector.Page page2;
		private LidorSystems.Collector.Page page3;
		private LidorSystems.Collector.Page page4;
		private LidorSystems.Collector.Page page5;
		private LidorSystems.Collector.Page page6;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.CheckBox useTheme;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox colorScheme;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button btnAdd;
		private System.Windows.Forms.ComboBox visualStyle;
		private System.Windows.Forms.Button btnArrange;
		private LidorSystems.Collector.Page pgPanel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			LidorSystems.Collector.Style.GroupStyle groupStyle1 = new LidorSystems.Collector.Style.GroupStyle();
			LidorSystems.Collector.Style.GroupStyle groupStyle2 = new LidorSystems.Collector.Style.GroupStyle();
			this.pgPanel = new LidorSystems.Collector.Page();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.label3 = new System.Windows.Forms.Label();
			this.visualStyle = new System.Windows.Forms.ComboBox();
			this.useTheme = new System.Windows.Forms.CheckBox();
			this.label1 = new System.Windows.Forms.Label();
			this.colorScheme = new System.Windows.Forms.ComboBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.btnArrange = new System.Windows.Forms.Button();
			this.rbCascade = new System.Windows.Forms.RadioButton();
			this.rbVertical = new System.Windows.Forms.RadioButton();
			this.rbHorizontal = new System.Windows.Forms.RadioButton();
			this.rbTiled = new System.Windows.Forms.RadioButton();
			this.btnAdd = new System.Windows.Forms.Button();
			this.group2 = new LidorSystems.Collector.Group();
			this.page2 = new LidorSystems.Collector.Page();
			this.page3 = new LidorSystems.Collector.Page();
			this.page4 = new LidorSystems.Collector.Page();
			this.group3 = new LidorSystems.Collector.Group();
			this.page5 = new LidorSystems.Collector.Page();
			this.page6 = new LidorSystems.Collector.Page();
			this.pgPanel.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.group2)).BeginInit();
			this.group2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.group3)).BeginInit();
			this.group3.SuspendLayout();
			this.SuspendLayout();
			// 
			// pgPanel
			// 
			this.pgPanel.Controls.Add(this.groupBox2);
			this.pgPanel.Controls.Add(this.groupBox1);
			this.pgPanel.Controls.Add(this.btnAdd);
			this.pgPanel.Dock = System.Windows.Forms.DockStyle.Right;
			this.pgPanel.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F);
			this.pgPanel.Location = new System.Drawing.Point(453, 0);
			this.pgPanel.Name = "pgPanel";
			this.pgPanel.Size = new System.Drawing.Size(179, 374);
			this.pgPanel.TabIndex = 0;
			this.pgPanel.TableObject = null;
			this.pgPanel.Text = "page1";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.label3);
			this.groupBox2.Controls.Add(this.visualStyle);
			this.groupBox2.Controls.Add(this.useTheme);
			this.groupBox2.Controls.Add(this.label1);
			this.groupBox2.Controls.Add(this.colorScheme);
			this.groupBox2.Location = new System.Drawing.Point(8, 170);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(164, 156);
			this.groupBox2.TabIndex = 1;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Style";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(12, 26);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(82, 16);
			this.label3.TabIndex = 0;
			this.label3.Text = "Visual style";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// visualStyle
			// 
			this.visualStyle.Items.AddRange(new object[] {
															 "Default",
															 "Classic",
															 "Office2003",
															 "VS2003",
															 "VS2005"});
			this.visualStyle.Location = new System.Drawing.Point(12, 44);
			this.visualStyle.Name = "visualStyle";
			this.visualStyle.Size = new System.Drawing.Size(116, 23);
			this.visualStyle.TabIndex = 1;
			this.visualStyle.Text = "Default";
			this.visualStyle.SelectedIndexChanged += new System.EventHandler(this.visualStyle_SelectedIndexChanged);
			// 
			// useTheme
			// 
			this.useTheme.Location = new System.Drawing.Point(12, 72);
			this.useTheme.Name = "useTheme";
			this.useTheme.Size = new System.Drawing.Size(102, 24);
			this.useTheme.TabIndex = 2;
			this.useTheme.Text = "Use Themes";
			this.useTheme.CheckedChanged += new System.EventHandler(this.useTheme_CheckedChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(12, 102);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(82, 16);
			this.label1.TabIndex = 3;
			this.label1.Text = "Color scheme";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// colorScheme
			// 
			this.colorScheme.Items.AddRange(new object[] {
															 "Default",
															 "Carrot",
															 "Coral",
															 "DarkForest",
															 "DarkWood",
															 "DeepSea",
															 "Forest",
															 "Gold",
															 "GoldRose",
															 "Lily",
															 "Metalic",
															 "Midnight",
															 "Rose",
															 "Sand",
															 "Sea",
															 "Silver",
															 "Sky",
															 "Strawberry",
															 "Sunset",
															 "Vinegar",
															 "Violet",
															 "Wood"});
			this.colorScheme.Location = new System.Drawing.Point(12, 120);
			this.colorScheme.Name = "colorScheme";
			this.colorScheme.Size = new System.Drawing.Size(116, 23);
			this.colorScheme.TabIndex = 4;
			this.colorScheme.Text = "Default";
			this.colorScheme.SelectedIndexChanged += new System.EventHandler(this.colorScheme_SelectedIndexChanged);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.btnArrange);
			this.groupBox1.Controls.Add(this.rbCascade);
			this.groupBox1.Controls.Add(this.rbVertical);
			this.groupBox1.Controls.Add(this.rbHorizontal);
			this.groupBox1.Controls.Add(this.rbTiled);
			this.groupBox1.Location = new System.Drawing.Point(8, 6);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(164, 160);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Arrange Windows";
			// 
			// btnArrange
			// 
			this.btnArrange.BackColor = System.Drawing.SystemColors.Control;
			this.btnArrange.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnArrange.Location = new System.Drawing.Point(80, 126);
			this.btnArrange.Name = "btnArrange";
			this.btnArrange.Size = new System.Drawing.Size(72, 24);
			this.btnArrange.TabIndex = 4;
			this.btnArrange.Text = "Arrange";
			this.btnArrange.Click += new System.EventHandler(this.btnArrange_Click);
			// 
			// rbCascade
			// 
			this.rbCascade.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbCascade.Location = new System.Drawing.Point(12, 94);
			this.rbCascade.Name = "rbCascade";
			this.rbCascade.Size = new System.Drawing.Size(94, 24);
			this.rbCascade.TabIndex = 3;
			this.rbCascade.Text = "Cascade";
			// 
			// rbVertical
			// 
			this.rbVertical.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbVertical.Location = new System.Drawing.Point(12, 70);
			this.rbVertical.Name = "rbVertical";
			this.rbVertical.Size = new System.Drawing.Size(94, 24);
			this.rbVertical.TabIndex = 2;
			this.rbVertical.Text = "Vertical";
			// 
			// rbHorizontal
			// 
			this.rbHorizontal.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbHorizontal.Location = new System.Drawing.Point(12, 46);
			this.rbHorizontal.Name = "rbHorizontal";
			this.rbHorizontal.Size = new System.Drawing.Size(94, 24);
			this.rbHorizontal.TabIndex = 1;
			this.rbHorizontal.Text = "Horizontal";
			// 
			// rbTiled
			// 
			this.rbTiled.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbTiled.Location = new System.Drawing.Point(12, 22);
			this.rbTiled.Name = "rbTiled";
			this.rbTiled.Size = new System.Drawing.Size(94, 24);
			this.rbTiled.TabIndex = 0;
			this.rbTiled.Text = "Tiled";
			// 
			// btnAdd
			// 
			this.btnAdd.BackColor = System.Drawing.SystemColors.Control;
			this.btnAdd.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnAdd.Location = new System.Drawing.Point(22, 334);
			this.btnAdd.Name = "btnAdd";
			this.btnAdd.Size = new System.Drawing.Size(138, 24);
			this.btnAdd.TabIndex = 0;
			this.btnAdd.Text = "Create New Window";
			this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
			// 
			// group2
			// 
			this.group2.Controls.Add(this.page2);
			this.group2.Controls.Add(this.page3);
			this.group2.Controls.Add(this.page4);
			this.group2.ControlState = LidorSystems.Collector.ControlState.Framed;
			this.group2.Cursor = System.Windows.Forms.Cursors.Default;
			this.group2.Location = new System.Drawing.Point(28, 31);
			this.group2.Name = "group2";
			this.group2.Pages.AddRange(new LidorSystems.Collector.Page[] {
																			 this.page2,
																			 this.page3,
																			 this.page4});
			this.group2.SelectedPage = this.page4;
			this.group2.Size = new System.Drawing.Size(257, 137);
			groupStyle1.ContextMenuButton = false;
			groupStyle1.MaximizeButton = true;
			groupStyle1.MinimizeButton = true;
			this.group2.Style = groupStyle1;
			this.group2.TabIndex = 1;
			this.group2.Text = "group2";
			// 
			// page2
			// 
			this.page2.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.page2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F);
			this.page2.Location = new System.Drawing.Point(4, 46);
			this.page2.Name = "page2";
			this.page2.Size = new System.Drawing.Size(249, 87);
			this.page2.StyleFromParent = true;
			this.page2.TabIndex = 0;
			this.page2.TableObject = null;
			this.page2.Text = "page2";
			// 
			// page3
			// 
			this.page3.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.page3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F);
			this.page3.Location = new System.Drawing.Point(4, 46);
			this.page3.Name = "page3";
			this.page3.Size = new System.Drawing.Size(249, 87);
			this.page3.StyleFromParent = true;
			this.page3.TabIndex = 1;
			this.page3.TableObject = null;
			this.page3.Text = "page3";
			// 
			// page4
			// 
			this.page4.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.page4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F);
			this.page4.Location = new System.Drawing.Point(4, 46);
			this.page4.Name = "page4";
			this.page4.Size = new System.Drawing.Size(249, 87);
			this.page4.StyleFromParent = true;
			this.page4.TabIndex = 2;
			this.page4.TableObject = null;
			this.page4.Text = "page4";
			// 
			// group3
			// 
			this.group3.Controls.Add(this.page5);
			this.group3.Controls.Add(this.page6);
			this.group3.ControlState = LidorSystems.Collector.ControlState.Framed;
			this.group3.Cursor = System.Windows.Forms.Cursors.Default;
			this.group3.Location = new System.Drawing.Point(168, 139);
			this.group3.Name = "group3";
			this.group3.Pages.AddRange(new LidorSystems.Collector.Page[] {
																			 this.page5,
																			 this.page6});
			this.group3.SelectedPage = this.page6;
			this.group3.Size = new System.Drawing.Size(232, 152);
			groupStyle2.ContextMenuButton = false;
			groupStyle2.MaximizeButton = true;
			groupStyle2.MinimizeButton = true;
			groupStyle2.Orientation = LidorSystems.Collector.Style.TabOrientation.Bottom;
			this.group3.Style = groupStyle2;
			this.group3.TabIndex = 2;
			this.group3.Text = "group3";
			// 
			// page5
			// 
			this.page5.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.page5.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F);
			this.page5.Location = new System.Drawing.Point(4, 25);
			this.page5.Name = "page5";
			this.page5.Size = new System.Drawing.Size(224, 102);
			this.page5.StyleFromParent = true;
			this.page5.TabIndex = 0;
			this.page5.TableObject = null;
			this.page5.Text = "page5";
			// 
			// page6
			// 
			this.page6.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.page6.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F);
			this.page6.Location = new System.Drawing.Point(4, 25);
			this.page6.Name = "page6";
			this.page6.Size = new System.Drawing.Size(224, 102);
			this.page6.StyleFromParent = true;
			this.page6.TabIndex = 1;
			this.page6.TableObject = null;
			this.page6.Text = "page6";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(632, 374);
			this.Controls.Add(this.pgPanel);
			this.Controls.Add(this.group2);
			this.Controls.Add(this.group3);
			this.Name = "Form1";
			this.Text = "Standard MDI";
			this.pgPanel.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.group2)).EndInit();
			this.group2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.group3)).EndInit();
			this.group3.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		#region Arrange Windows
		private void btnArrange_Click(object sender, System.EventArgs e)
		{
			if (rbTiled.Checked)
				ArrangeWindows(0);
			else if (rbHorizontal.Checked)
				ArrangeWindows(1);
			else if (rbVertical.Checked)
				ArrangeWindows(2);
			else if (rbCascade.Checked)
				ArrangeWindows(3);
		}

		private Size GetEmptyClientSpace()
		{
			Size emptySpace = this.ClientSize;
			foreach (Control ctrl in this.Controls)
			{
				switch (ctrl.Dock)
				{
					case DockStyle.Left:
					case DockStyle.Right:
						emptySpace.Width -= ctrl.Width;
						break;

					case DockStyle.Top:
					case DockStyle.Bottom:
						emptySpace.Height -= ctrl.Height;
						break;
				}
			}

			return emptySpace;
		}

		private int GetActiveWindows()
		{
			int num = 0;
			Group currentGroup = null;
			foreach (Control ctrl in this.Controls)
			{
				if (ctrl is Group)
				{
					currentGroup = (Group)ctrl;
					if (currentGroup.ControlState == ControlState.Framed || (currentGroup.Dock == DockStyle.Fill && currentGroup.WindowState == FormWindowState.Maximized))
						num++;
				}
			}

			return num;
		}

		private void SetWindowsToNormalState()
		{
			Group currentGroup = null;
			foreach (Control ctrl in this.Controls)
			{
				if (ctrl is Group)
				{
					currentGroup = (Group)ctrl;
					if (currentGroup.ControlState == ControlState.Framed || (currentGroup.Dock == DockStyle.Fill && currentGroup.WindowState == FormWindowState.Maximized))
						currentGroup.WindowState = FormWindowState.Normal;
				}
			}
		}

		private Group GetTopGroup()
		{
			Group currentGroup = null;
			for (int i = 0; i < this.Controls.Count; i++)
			{
				if (this.Controls[i] is Group)
				{
					currentGroup = (Group)this.Controls[i];
					if (currentGroup.ControlState == ControlState.Framed)
						break;
				}
			}

			return currentGroup;
		}

		private int GetColumns(int nWin)
		{
			int i = 1;
			while (nWin > i*i)
				i++;

			return i;
		}

		private int GetRows(int nWin, int nCol)
		{
			int i = 1;
			while (nCol*i < nWin)
				i++;

			return i;
		}

		private void ArrangeWindows(int orderType)
		{
			int numWindows = GetActiveWindows();
			if (numWindows > 0)
			{
				SetWindowsToNormalState();
				Size clientSize = GetEmptyClientSpace();
				int distance = 25;
				int prefWidth = clientSize.Width/numWindows;
				int prefHeight = clientSize.Height/numWindows;

				Group currentGroup = null;
				Group topGroup = GetTopGroup();
				PointF pos = new PointF();
				int counter = 1;
				switch (orderType)
				{
					case 0:
						int nCol = GetColumns(numWindows);
						int nRow = GetRows(numWindows, nCol);

						prefWidth = clientSize.Width/nCol;
						prefHeight = clientSize.Height/nRow;
						pos = new PointF(pos.X+clientSize.Width, pos.Y+clientSize.Height);

						for (int i = this.Controls.Count-1; i >= 0; i--)
						{
							if (this.Controls[i] is Group && this.Controls[i] != topGroup)
							{
								currentGroup = (Group)this.Controls[i];
								if (currentGroup.ControlState == ControlState.Framed)
								{
									currentGroup.Location = new Point((int)pos.X-prefWidth, (int)pos.Y-prefHeight);
									currentGroup.Size = new Size(prefWidth, prefHeight);

									if (counter < nRow)
									{
										pos = new PointF((int)pos.X, (int)pos.Y-prefHeight);
										counter++;
									}
									else
									{
										pos = new PointF((int)pos.X-prefWidth, clientSize.Height);
										counter = 1;
									}
								}
							}
						}

						if (topGroup != null)
						{
							topGroup.Location = new Point();
							topGroup.Size = new Size(prefWidth, (int)pos.Y);
						}
						break;

					case 1:
						pos.Y += clientSize.Height-prefHeight;
						for (int i = this.Controls.Count-1; i >= 0; i--)
						{
							if (this.Controls[i] is Group && this.Controls[i] != topGroup)
							{
								currentGroup = (Group)this.Controls[i];
								if (currentGroup.ControlState == ControlState.Framed)
								{
									currentGroup.Location = new Point((int)pos.X, (int)pos.Y);
									currentGroup.Size = new Size(clientSize.Width, prefHeight);

									pos.Y -= (prefHeight+0.35f);
								}
							}
						}

						if (topGroup != null)
						{
							topGroup.Location = new Point();
							topGroup.Size = new Size(clientSize.Width, prefHeight);
						}
						break;

					case 2:
						pos.X += clientSize.Width-prefWidth;
						for (int i = this.Controls.Count-1; i >= 0; i--)
						{
							if (this.Controls[i] is Group && this.Controls[i] != topGroup)
							{
								currentGroup = (Group)this.Controls[i];
								if (currentGroup.ControlState == ControlState.Framed)
								{
									currentGroup.Location = new Point((int)pos.X, (int)pos.Y);
									currentGroup.Size = new Size(prefWidth, clientSize.Height);

									pos.X -= (prefWidth+0.35f);
								}
							}
						}

						if (topGroup != null)
						{
							topGroup.Location = new Point();
							topGroup.Size = new Size(prefWidth, clientSize.Height);
						}
						break;

					case 3:
						int sizeReduction = distance*(numWindows-1);
						for (int i = this.Controls.Count-1; i >= 0; i--)
						{
							if (this.Controls[i] is Group && this.Controls[i] != topGroup)
							{
								currentGroup = (Group)this.Controls[i];
								if (currentGroup.ControlState == ControlState.Framed)
								{
									currentGroup.Location = new Point((int)pos.X, (int)pos.Y);
									currentGroup.Size = new Size(clientSize.Width-sizeReduction, clientSize.Height-sizeReduction);

									pos = new PointF(pos.X+distance, pos.Y+distance);
									counter++;
								}
							}
						}

						if (topGroup != null)
						{
							topGroup.Location = new Point((int)pos.X, (int)pos.Y);
							topGroup.Size = new Size(clientSize.Width-sizeReduction, clientSize.Height-sizeReduction);
						}
						break;
				}			
			}
		}

		#endregion

		#region Style
		private VisualStyle GetCurrentVisualStyle()
		{
			VisualStyle vStyle = VisualStyle.Default;
			switch (visualStyle.SelectedItem.ToString())
			{
				case "Classic":
					vStyle = VisualStyle.Classic;
					break;
				case "Office2003":
					vStyle = VisualStyle.Office2003;
					break;
				case "VS2003":
					vStyle = VisualStyle.VS2003;
					break;
				case "VS2005":
					vStyle = VisualStyle.VS2005;
					break;
				default:
					vStyle = VisualStyle.Default;
					break;
			}

			return vStyle;
		}

		private void visualStyle_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			VisualStyle vStyle = GetCurrentVisualStyle();

			foreach (Control ctrl in this.Controls)
			{
				if (ctrl is Group)
					((Group)ctrl).VisualStyle = vStyle;
				else if (ctrl is Page)
					((Page)ctrl).VisualStyle = vStyle;
			}
		}

		private void useTheme_CheckedChanged(object sender, System.EventArgs e)
		{
			foreach (Control ctrl in this.Controls)
			{
				if (ctrl is Group)
					((Group)ctrl).UseTheme = useTheme.Checked;
				else if (ctrl is Page)
					((Page)ctrl).UseTheme = useTheme.Checked;
			}
		}

		private ColorScheme GetCurrentColorScheme()
		{
			ColorScheme scheme = ColorScheme.Default;
			switch (colorScheme.SelectedItem.ToString())
			{
				case "Carrot":
					scheme = ColorScheme.Carrot;
					break;
				case "Coral":
					scheme = ColorScheme.Coral;
					break;
				case "DarkForest":
					scheme = ColorScheme.DarkForest;
					break;
				case "DarkWood":
					scheme = ColorScheme.DarkWood;
					break;
				case "DeepSea":
					scheme = ColorScheme.DeepSea;
					break;
				case "Forest":
					scheme = ColorScheme.Forest;
					break;
				case "Gold":
					scheme = ColorScheme.Gold;
					break;
				case "GoldRose":
					scheme = ColorScheme.GoldRose;
					break;
				case "Lily":
					scheme = ColorScheme.Lily;
					break;
				case "Metalic":
					scheme = ColorScheme.Metalic;
					break;
				case "Midnight":
					scheme = ColorScheme.Midnight;
					break;
				case "Rose":
					scheme = ColorScheme.Rose;
					break;
				case "Sand":
					scheme = ColorScheme.Sand;
					break;
				case "Sea":
					scheme = ColorScheme.Sea;
					break;
				case "Silver":
					scheme = ColorScheme.Silver;
					break;
				case "Strawberry":
					scheme = ColorScheme.Strawberry;
					break;
				case "Sunset":
					scheme = ColorScheme.Sunset;
					break;
				case "Vinegar":
					scheme = ColorScheme.Vinegar;
					break;
				case "Violet":
					scheme = ColorScheme.Violet;
					break;
				case "Wood":
					scheme = ColorScheme.Wood;
					break;
				case "Sky":
				default:
					scheme = ColorScheme.Default;
					break;
			}

			return scheme;
		}

		private void colorScheme_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			ColorScheme scheme = GetCurrentColorScheme();
			foreach (Control ctrl in this.Controls)
			{
				if (ctrl is Group)
				{
					if (((Group)ctrl).Style != null)
						((Group)ctrl).Style.ColorScheme = scheme;
				}
				else if (ctrl is Page)
				{
					if (((Page)ctrl).Style != null)
						((Page)ctrl).Style.ColorScheme = scheme;
				}
			}
		}
		#endregion

		#region Creation of New Windows
		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			Group newGroup = new Group();
			newGroup.Text = "Group" + ((int)(this.Controls.Count+1)).ToString();
			newGroup.ControlState = ControlState.Framed;

			if (newGroup.Style != null)
			{
				newGroup.Style.ContextMenuButton = false;
				newGroup.Style.MaximizeButton = true;
				newGroup.Style.MinimizeButton = true;

				newGroup.Style.ColorScheme = GetCurrentColorScheme();
			}
			newGroup.VisualStyle = GetCurrentVisualStyle();
			newGroup.UseTheme = useTheme.Checked;

			Size clientSize = GetEmptyClientSpace();
			newGroup.Location = new Point(clientSize.Width/4, clientSize.Height/4);
			newGroup.Size = new Size(clientSize.Width/2, clientSize.Height/2);

			Page newPage = new Page();
			newPage.Text = "Page1";
			newPage.StyleFromParent = true;
			newGroup.Pages.Add(newPage);

			this.Controls.Add(newGroup);
			newGroup.Focus();
		}
		#endregion
	}
}
